package consts

import "errors"

const (
	AuthHeader = "Authorization"
	AuthPrefix = "Bearer"

	AnonymousUser = "anonymous"

	AuthMiddlewareKey = "auth.user"
)

var (
	ErrNotValidToken  = errors.New("无效的 JWT 令牌")
	ErrJWTFormatError = errors.New("JWT 格式错误")
	ErrNotBearerType  = errors.New("不是 Bearer 类型")
	ErrEmptyResponse  = errors.New("我们的服务器返回了空请求，可能某些环节出了问题")
	ErrTokenError     = errors.New("token 类型错误")
)
