// Code generated by ent, DO NOT EDIT.

package documentblock

import (
	"time"

	"entgo.io/ent/dialect/sql"
	"entgo.io/ent/dialect/sql/sqlgraph"
	"leafdev.top/leaf/rag/ent/predicate"
)

// ID filters vertices based on their ID field.
func ID(id int) predicate.DocumentBlock {
	return predicate.DocumentBlock(sql.FieldEQ(FieldID, id))
}

// IDEQ applies the EQ predicate on the ID field.
func IDEQ(id int) predicate.DocumentBlock {
	return predicate.DocumentBlock(sql.FieldEQ(FieldID, id))
}

// IDNEQ applies the NEQ predicate on the ID field.
func IDNEQ(id int) predicate.DocumentBlock {
	return predicate.DocumentBlock(sql.FieldNEQ(FieldID, id))
}

// IDIn applies the In predicate on the ID field.
func IDIn(ids ...int) predicate.DocumentBlock {
	return predicate.DocumentBlock(sql.FieldIn(FieldID, ids...))
}

// IDNotIn applies the NotIn predicate on the ID field.
func IDNotIn(ids ...int) predicate.DocumentBlock {
	return predicate.DocumentBlock(sql.FieldNotIn(FieldID, ids...))
}

// IDGT applies the GT predicate on the ID field.
func IDGT(id int) predicate.DocumentBlock {
	return predicate.DocumentBlock(sql.FieldGT(FieldID, id))
}

// IDGTE applies the GTE predicate on the ID field.
func IDGTE(id int) predicate.DocumentBlock {
	return predicate.DocumentBlock(sql.FieldGTE(FieldID, id))
}

// IDLT applies the LT predicate on the ID field.
func IDLT(id int) predicate.DocumentBlock {
	return predicate.DocumentBlock(sql.FieldLT(FieldID, id))
}

// IDLTE applies the LTE predicate on the ID field.
func IDLTE(id int) predicate.DocumentBlock {
	return predicate.DocumentBlock(sql.FieldLTE(FieldID, id))
}

// Content applies equality check predicate on the "content" field. It's identical to ContentEQ.
func Content(v string) predicate.DocumentBlock {
	return predicate.DocumentBlock(sql.FieldEQ(FieldContent, v))
}

// Order applies equality check predicate on the "order" field. It's identical to OrderEQ.
func Order(v int64) predicate.DocumentBlock {
	return predicate.DocumentBlock(sql.FieldEQ(FieldOrder, v))
}

// DocumentID applies equality check predicate on the "document_id" field. It's identical to DocumentIDEQ.
func DocumentID(v int64) predicate.DocumentBlock {
	return predicate.DocumentBlock(sql.FieldEQ(FieldDocumentID, v))
}

// UserID applies equality check predicate on the "user_id" field. It's identical to UserIDEQ.
func UserID(v string) predicate.DocumentBlock {
	return predicate.DocumentBlock(sql.FieldEQ(FieldUserID, v))
}

// CreatedAt applies equality check predicate on the "created_at" field. It's identical to CreatedAtEQ.
func CreatedAt(v time.Time) predicate.DocumentBlock {
	return predicate.DocumentBlock(sql.FieldEQ(FieldCreatedAt, v))
}

// UpdatedAt applies equality check predicate on the "updated_at" field. It's identical to UpdatedAtEQ.
func UpdatedAt(v time.Time) predicate.DocumentBlock {
	return predicate.DocumentBlock(sql.FieldEQ(FieldUpdatedAt, v))
}

// ContentEQ applies the EQ predicate on the "content" field.
func ContentEQ(v string) predicate.DocumentBlock {
	return predicate.DocumentBlock(sql.FieldEQ(FieldContent, v))
}

// ContentNEQ applies the NEQ predicate on the "content" field.
func ContentNEQ(v string) predicate.DocumentBlock {
	return predicate.DocumentBlock(sql.FieldNEQ(FieldContent, v))
}

// ContentIn applies the In predicate on the "content" field.
func ContentIn(vs ...string) predicate.DocumentBlock {
	return predicate.DocumentBlock(sql.FieldIn(FieldContent, vs...))
}

// ContentNotIn applies the NotIn predicate on the "content" field.
func ContentNotIn(vs ...string) predicate.DocumentBlock {
	return predicate.DocumentBlock(sql.FieldNotIn(FieldContent, vs...))
}

// ContentGT applies the GT predicate on the "content" field.
func ContentGT(v string) predicate.DocumentBlock {
	return predicate.DocumentBlock(sql.FieldGT(FieldContent, v))
}

// ContentGTE applies the GTE predicate on the "content" field.
func ContentGTE(v string) predicate.DocumentBlock {
	return predicate.DocumentBlock(sql.FieldGTE(FieldContent, v))
}

// ContentLT applies the LT predicate on the "content" field.
func ContentLT(v string) predicate.DocumentBlock {
	return predicate.DocumentBlock(sql.FieldLT(FieldContent, v))
}

// ContentLTE applies the LTE predicate on the "content" field.
func ContentLTE(v string) predicate.DocumentBlock {
	return predicate.DocumentBlock(sql.FieldLTE(FieldContent, v))
}

// ContentContains applies the Contains predicate on the "content" field.
func ContentContains(v string) predicate.DocumentBlock {
	return predicate.DocumentBlock(sql.FieldContains(FieldContent, v))
}

// ContentHasPrefix applies the HasPrefix predicate on the "content" field.
func ContentHasPrefix(v string) predicate.DocumentBlock {
	return predicate.DocumentBlock(sql.FieldHasPrefix(FieldContent, v))
}

// ContentHasSuffix applies the HasSuffix predicate on the "content" field.
func ContentHasSuffix(v string) predicate.DocumentBlock {
	return predicate.DocumentBlock(sql.FieldHasSuffix(FieldContent, v))
}

// ContentEqualFold applies the EqualFold predicate on the "content" field.
func ContentEqualFold(v string) predicate.DocumentBlock {
	return predicate.DocumentBlock(sql.FieldEqualFold(FieldContent, v))
}

// ContentContainsFold applies the ContainsFold predicate on the "content" field.
func ContentContainsFold(v string) predicate.DocumentBlock {
	return predicate.DocumentBlock(sql.FieldContainsFold(FieldContent, v))
}

// OrderEQ applies the EQ predicate on the "order" field.
func OrderEQ(v int64) predicate.DocumentBlock {
	return predicate.DocumentBlock(sql.FieldEQ(FieldOrder, v))
}

// OrderNEQ applies the NEQ predicate on the "order" field.
func OrderNEQ(v int64) predicate.DocumentBlock {
	return predicate.DocumentBlock(sql.FieldNEQ(FieldOrder, v))
}

// OrderIn applies the In predicate on the "order" field.
func OrderIn(vs ...int64) predicate.DocumentBlock {
	return predicate.DocumentBlock(sql.FieldIn(FieldOrder, vs...))
}

// OrderNotIn applies the NotIn predicate on the "order" field.
func OrderNotIn(vs ...int64) predicate.DocumentBlock {
	return predicate.DocumentBlock(sql.FieldNotIn(FieldOrder, vs...))
}

// OrderGT applies the GT predicate on the "order" field.
func OrderGT(v int64) predicate.DocumentBlock {
	return predicate.DocumentBlock(sql.FieldGT(FieldOrder, v))
}

// OrderGTE applies the GTE predicate on the "order" field.
func OrderGTE(v int64) predicate.DocumentBlock {
	return predicate.DocumentBlock(sql.FieldGTE(FieldOrder, v))
}

// OrderLT applies the LT predicate on the "order" field.
func OrderLT(v int64) predicate.DocumentBlock {
	return predicate.DocumentBlock(sql.FieldLT(FieldOrder, v))
}

// OrderLTE applies the LTE predicate on the "order" field.
func OrderLTE(v int64) predicate.DocumentBlock {
	return predicate.DocumentBlock(sql.FieldLTE(FieldOrder, v))
}

// DocumentIDEQ applies the EQ predicate on the "document_id" field.
func DocumentIDEQ(v int64) predicate.DocumentBlock {
	return predicate.DocumentBlock(sql.FieldEQ(FieldDocumentID, v))
}

// DocumentIDNEQ applies the NEQ predicate on the "document_id" field.
func DocumentIDNEQ(v int64) predicate.DocumentBlock {
	return predicate.DocumentBlock(sql.FieldNEQ(FieldDocumentID, v))
}

// DocumentIDIn applies the In predicate on the "document_id" field.
func DocumentIDIn(vs ...int64) predicate.DocumentBlock {
	return predicate.DocumentBlock(sql.FieldIn(FieldDocumentID, vs...))
}

// DocumentIDNotIn applies the NotIn predicate on the "document_id" field.
func DocumentIDNotIn(vs ...int64) predicate.DocumentBlock {
	return predicate.DocumentBlock(sql.FieldNotIn(FieldDocumentID, vs...))
}

// DocumentIDGT applies the GT predicate on the "document_id" field.
func DocumentIDGT(v int64) predicate.DocumentBlock {
	return predicate.DocumentBlock(sql.FieldGT(FieldDocumentID, v))
}

// DocumentIDGTE applies the GTE predicate on the "document_id" field.
func DocumentIDGTE(v int64) predicate.DocumentBlock {
	return predicate.DocumentBlock(sql.FieldGTE(FieldDocumentID, v))
}

// DocumentIDLT applies the LT predicate on the "document_id" field.
func DocumentIDLT(v int64) predicate.DocumentBlock {
	return predicate.DocumentBlock(sql.FieldLT(FieldDocumentID, v))
}

// DocumentIDLTE applies the LTE predicate on the "document_id" field.
func DocumentIDLTE(v int64) predicate.DocumentBlock {
	return predicate.DocumentBlock(sql.FieldLTE(FieldDocumentID, v))
}

// UserIDEQ applies the EQ predicate on the "user_id" field.
func UserIDEQ(v string) predicate.DocumentBlock {
	return predicate.DocumentBlock(sql.FieldEQ(FieldUserID, v))
}

// UserIDNEQ applies the NEQ predicate on the "user_id" field.
func UserIDNEQ(v string) predicate.DocumentBlock {
	return predicate.DocumentBlock(sql.FieldNEQ(FieldUserID, v))
}

// UserIDIn applies the In predicate on the "user_id" field.
func UserIDIn(vs ...string) predicate.DocumentBlock {
	return predicate.DocumentBlock(sql.FieldIn(FieldUserID, vs...))
}

// UserIDNotIn applies the NotIn predicate on the "user_id" field.
func UserIDNotIn(vs ...string) predicate.DocumentBlock {
	return predicate.DocumentBlock(sql.FieldNotIn(FieldUserID, vs...))
}

// UserIDGT applies the GT predicate on the "user_id" field.
func UserIDGT(v string) predicate.DocumentBlock {
	return predicate.DocumentBlock(sql.FieldGT(FieldUserID, v))
}

// UserIDGTE applies the GTE predicate on the "user_id" field.
func UserIDGTE(v string) predicate.DocumentBlock {
	return predicate.DocumentBlock(sql.FieldGTE(FieldUserID, v))
}

// UserIDLT applies the LT predicate on the "user_id" field.
func UserIDLT(v string) predicate.DocumentBlock {
	return predicate.DocumentBlock(sql.FieldLT(FieldUserID, v))
}

// UserIDLTE applies the LTE predicate on the "user_id" field.
func UserIDLTE(v string) predicate.DocumentBlock {
	return predicate.DocumentBlock(sql.FieldLTE(FieldUserID, v))
}

// UserIDContains applies the Contains predicate on the "user_id" field.
func UserIDContains(v string) predicate.DocumentBlock {
	return predicate.DocumentBlock(sql.FieldContains(FieldUserID, v))
}

// UserIDHasPrefix applies the HasPrefix predicate on the "user_id" field.
func UserIDHasPrefix(v string) predicate.DocumentBlock {
	return predicate.DocumentBlock(sql.FieldHasPrefix(FieldUserID, v))
}

// UserIDHasSuffix applies the HasSuffix predicate on the "user_id" field.
func UserIDHasSuffix(v string) predicate.DocumentBlock {
	return predicate.DocumentBlock(sql.FieldHasSuffix(FieldUserID, v))
}

// UserIDEqualFold applies the EqualFold predicate on the "user_id" field.
func UserIDEqualFold(v string) predicate.DocumentBlock {
	return predicate.DocumentBlock(sql.FieldEqualFold(FieldUserID, v))
}

// UserIDContainsFold applies the ContainsFold predicate on the "user_id" field.
func UserIDContainsFold(v string) predicate.DocumentBlock {
	return predicate.DocumentBlock(sql.FieldContainsFold(FieldUserID, v))
}

// CreatedAtEQ applies the EQ predicate on the "created_at" field.
func CreatedAtEQ(v time.Time) predicate.DocumentBlock {
	return predicate.DocumentBlock(sql.FieldEQ(FieldCreatedAt, v))
}

// CreatedAtNEQ applies the NEQ predicate on the "created_at" field.
func CreatedAtNEQ(v time.Time) predicate.DocumentBlock {
	return predicate.DocumentBlock(sql.FieldNEQ(FieldCreatedAt, v))
}

// CreatedAtIn applies the In predicate on the "created_at" field.
func CreatedAtIn(vs ...time.Time) predicate.DocumentBlock {
	return predicate.DocumentBlock(sql.FieldIn(FieldCreatedAt, vs...))
}

// CreatedAtNotIn applies the NotIn predicate on the "created_at" field.
func CreatedAtNotIn(vs ...time.Time) predicate.DocumentBlock {
	return predicate.DocumentBlock(sql.FieldNotIn(FieldCreatedAt, vs...))
}

// CreatedAtGT applies the GT predicate on the "created_at" field.
func CreatedAtGT(v time.Time) predicate.DocumentBlock {
	return predicate.DocumentBlock(sql.FieldGT(FieldCreatedAt, v))
}

// CreatedAtGTE applies the GTE predicate on the "created_at" field.
func CreatedAtGTE(v time.Time) predicate.DocumentBlock {
	return predicate.DocumentBlock(sql.FieldGTE(FieldCreatedAt, v))
}

// CreatedAtLT applies the LT predicate on the "created_at" field.
func CreatedAtLT(v time.Time) predicate.DocumentBlock {
	return predicate.DocumentBlock(sql.FieldLT(FieldCreatedAt, v))
}

// CreatedAtLTE applies the LTE predicate on the "created_at" field.
func CreatedAtLTE(v time.Time) predicate.DocumentBlock {
	return predicate.DocumentBlock(sql.FieldLTE(FieldCreatedAt, v))
}

// UpdatedAtEQ applies the EQ predicate on the "updated_at" field.
func UpdatedAtEQ(v time.Time) predicate.DocumentBlock {
	return predicate.DocumentBlock(sql.FieldEQ(FieldUpdatedAt, v))
}

// UpdatedAtNEQ applies the NEQ predicate on the "updated_at" field.
func UpdatedAtNEQ(v time.Time) predicate.DocumentBlock {
	return predicate.DocumentBlock(sql.FieldNEQ(FieldUpdatedAt, v))
}

// UpdatedAtIn applies the In predicate on the "updated_at" field.
func UpdatedAtIn(vs ...time.Time) predicate.DocumentBlock {
	return predicate.DocumentBlock(sql.FieldIn(FieldUpdatedAt, vs...))
}

// UpdatedAtNotIn applies the NotIn predicate on the "updated_at" field.
func UpdatedAtNotIn(vs ...time.Time) predicate.DocumentBlock {
	return predicate.DocumentBlock(sql.FieldNotIn(FieldUpdatedAt, vs...))
}

// UpdatedAtGT applies the GT predicate on the "updated_at" field.
func UpdatedAtGT(v time.Time) predicate.DocumentBlock {
	return predicate.DocumentBlock(sql.FieldGT(FieldUpdatedAt, v))
}

// UpdatedAtGTE applies the GTE predicate on the "updated_at" field.
func UpdatedAtGTE(v time.Time) predicate.DocumentBlock {
	return predicate.DocumentBlock(sql.FieldGTE(FieldUpdatedAt, v))
}

// UpdatedAtLT applies the LT predicate on the "updated_at" field.
func UpdatedAtLT(v time.Time) predicate.DocumentBlock {
	return predicate.DocumentBlock(sql.FieldLT(FieldUpdatedAt, v))
}

// UpdatedAtLTE applies the LTE predicate on the "updated_at" field.
func UpdatedAtLTE(v time.Time) predicate.DocumentBlock {
	return predicate.DocumentBlock(sql.FieldLTE(FieldUpdatedAt, v))
}

// HasDocument applies the HasEdge predicate on the "document" edge.
func HasDocument() predicate.DocumentBlock {
	return predicate.DocumentBlock(func(s *sql.Selector) {
		step := sqlgraph.NewStep(
			sqlgraph.From(Table, FieldID),
			sqlgraph.Edge(sqlgraph.O2M, false, DocumentTable, DocumentColumn),
		)
		sqlgraph.HasNeighbors(s, step)
	})
}

// HasDocumentWith applies the HasEdge predicate on the "document" edge with a given conditions (other predicates).
func HasDocumentWith(preds ...predicate.Document) predicate.DocumentBlock {
	return predicate.DocumentBlock(func(s *sql.Selector) {
		step := newDocumentStep()
		sqlgraph.HasNeighborsWith(s, step, func(s *sql.Selector) {
			for _, p := range preds {
				p(s)
			}
		})
	})
}

// And groups predicates with the AND operator between them.
func And(predicates ...predicate.DocumentBlock) predicate.DocumentBlock {
	return predicate.DocumentBlock(sql.AndPredicates(predicates...))
}

// Or groups predicates with the OR operator between them.
func Or(predicates ...predicate.DocumentBlock) predicate.DocumentBlock {
	return predicate.DocumentBlock(sql.OrPredicates(predicates...))
}

// Not applies the not operator on the given predicate.
func Not(p predicate.DocumentBlock) predicate.DocumentBlock {
	return predicate.DocumentBlock(sql.NotPredicates(p))
}
