package cmd

import (
	"github.com/hibiken/asynq"
	"github.com/spf13/cobra"
	"leafdev.top/leaf/rag/internal/providers"
	"log"
)

var workerCommand = &cobra.Command{
	Use: "worker",

	Run: func(cmd *cobra.Command, args []string) {
		runWorker()
	},
}

func runWorker() {
	mux := asynq.NewServeMux()

	var asynqServer = providers.MustGet[asynq.Server]()

	//mux.HandleFunc(tasks.DocumentChunkTask, tasks.HandleDocumentChunkTask)
	//mux.HandleFunc(tasks.DocumentImportTask, tasks.HandleDocumentImportTask)

	if err := asynqServer.Run(mux); err != nil {
		log.Fatal(err)
	}

}
