package providers

import "go.uber.org/dig"

var Container = dig.New()

func Must(err error) {
	if err != nil {
		panic(err)
	}
}

// MustGet 方法，用于封装 Invoke 函数，然后将结果返回，类型是 T
func MustGet[T any]() *T {
	var t T
	Must(Container.Invoke(func(e *T) {
		t = *e
	}))
	return &t
}
