package providers

import (
	"github.com/redis/go-redis/v9"
)

func provideRedis() *redis.Client {
	var config = MustGet[GlobalConfig]()

	return redis.NewClient(&redis.Options{
		Addr:     config.Redis.Addr,
		Password: config.Redis.Pass,
		DB:       0, // use default DB
	})
}

func init() {
	Must(Container.Provide(provideRedis))
}
