package providers

import (
	"github.com/minio/minio-go/v7"
	"github.com/minio/minio-go/v7/pkg/credentials"
)

func ProvideS3Driver() (*minio.Client, error) {
	var config = MustGet[GlobalConfig]()
	return minio.New(config.S3.Endpoint, &minio.Options{
		Creds:  credentials.NewStaticV4(config.S3.AccessKeyID, config.S3.SecretAccessKey, ""),
		Secure: config.S3.UseSSL,
	})
}

func init() {
	Must(Container.Provide(ProvideS3Driver))
}
