package rag

import (
	"context"
	"github.com/mitchellh/mapstructure"
	ragApi "leafdev.top/leaf/rag/api/rag"
)

func (Service) ListDocument(ctx context.Context, req *ragApi.ListDocumentRequest) (*ragApi.ListDocumentResponse, error) {
	document, err := documentLogic.ListDocument(ctx, req.LibraryId)
	if err != nil {
		return nil, err
	}

	var documentApiResponse ragApi.ListDocumentResponse
	for _, document := range document {
		var documentApiResponseItem = ragApi.Document{
			Id:        int64(document.ID),
			Name:      document.Name,
			UserId:    document.UserID,
			LibraryId: document.LibraryID,
			CreatedAt: document.CreatedAt.String(),
			UpdatedAt: document.UpdatedAt.String(),
		}
		documentApiResponse.Documents = append(documentApiResponse.Documents, &documentApiResponseItem)
	}

	return &documentApiResponse, nil
}

func (Service) CreateDocument(ctx context.Context, req *ragApi.CreateDocumentRequest) (*ragApi.CreateDocumentResponse, error) {
	document, err := documentLogic.CreateDocument(ctx, req.LibraryId, req.Name)
	if err != nil {
		return nil, err
	}

	var documentApiResponse ragApi.CreateDocumentResponse
	err = mapstructure.Decode(document, &documentApiResponse)
	if err != nil {
		return nil, err
	}

	return &documentApiResponse, nil
}

//func (Service) UpdateDocument(ctx context.Context, _ *ragApi.UpdateDocumentRequest) (*ragApi.UpdateDocumentResponse, error) {
//	panic("implement me")
//}
